#ifndef TDA1004X
#define TDA1004X 1

#include <linux/dvb/frontend.h>
#include <linux/firmware.h>
#include "dvbdev.h"
#include "pll-lib.h"

struct tda1004x_cardspec 
{
	struct bus_i2c bus;
	struct dvbpll pll;

	int (*request_firmware) (struct tda1004x_cardspec* cardspec, const struct firmware **fw, const char* name);

	u8 demod_addr;
	u8 inversion:1;

	// internal fields
	u8 demod_type;
	u8 initialised:1;
	int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg);
	struct dvb_adapter *adapter;
	void* data;
};


int tda10045_init(struct tda1004x_cardspec* cardspec,
		  int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg),
		  struct dvb_adapter *dvb_adapter,
		  void *data);

int tda10046_init(struct tda1004x_cardspec* cardspec,
		  int (*ioctl) (struct dvb_frontend *frontend, unsigned int cmd, void *arg),
		  struct dvb_adapter *dvb_adapter,
		  void *data);

int tda1004x_shutdown(struct tda1004x_cardspec* cardspec);

int tda1004x_ioctl(struct tda1004x_cardspec* cardspec, struct dvb_frontend *fe, unsigned int cmd, void *arg);

#endif
